/***************************************************************************
                          client.h  -  description
                             -------------------
    begin                : Sat Sep 14 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CLIENT_H
#define CLIENT_H

#include <qobject.h>
#include "eventcue.h"

/**
  *@author Ivica Bukvic
  */

class QSocket;
class QServerSocket;
class RTMix;

class Client : public QObject
{
    Q_OBJECT
public:
    Client( RTMix *r, QString s, QString host, Q_UINT16 port );
    ~Client();

	int line;
	RTMix *ptr;
	QString Host;
	int Port;
	int Status;

public slots:
	void createConnection();
    void closeConnection();
	void sendStringToServer( QString );
    void sendToServer( struct eventCue * );
    //void socketReadyRead();
	//void setSocket( int );

private slots:
    void socketConnected();
    void socketConnectionClosed();
    void socketClosed();
    void socketError( int e );
    void CheckAuth();

private:
    QSocket *socket;
	QServerSocket *serverSocket;
	QString name;
	QString ParseNetEvent( struct eventCue *e );

signals:
	void EmitText( QString );
};

#endif
