/***************************************************************************
                          externaltimer.h  -  description
                             -------------------
    begin                : Fri Aug 30 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef EXTERNALTIMER_H
#define EXTERNALTIMER_H

#include <qvariant.h>
#include <qwidget.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLCDNumber;
class QLabel;

class ExternalTimer : public QWidget
{ 
    Q_OBJECT

public:
    ExternalTimer( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~ExternalTimer();

    QPalette pal;
    QColorGroup cg;

    QLabel* TimerLeftEdge;
    QLabel* TimerRightEdge;
    QLCDNumber* NHour;
    QLCDNumber* HourMinuteColumn;
    QLCDNumber* NMinute;
    QLCDNumber* MinuteSecondColumn;
    QLCDNumber* NTenSecond;
    QLCDNumber* NSecond;
    QLCDNumber* SecondCentisecondDot;
    QLCDNumber* NTenCentisecond;
    QLCDNumber* NCentisecond;
    QLabel* MinutesLabel;
    QLabel* HoursLabel;
    QLabel* DecisecondsLabel;
    QLabel* SecondsLabel;
    QLCDNumber* NTenMinute;

	void SetTimeCount( long );
	long GetTimeCount();

	void AdjustTimer();
	void UpdateCounter();
	void ResetCounter();

	void IncreaseHour();
	void DecreaseHour();
	void IncreaseTenMinute();
	void DecreaseTenMinute();
	void IncreaseMinute();
	void DecreaseMinute();
	void IncreaseTenSecond();
	void DecreaseTenSecond();
	void IncreaseSecond();
	void DecreaseSecond();
	void IncreaseTenCentisecond();
	void DecreaseTenCentisecond();
	void IncreaseCentisecond();
	void DecreaseCentisecond();

	void ChangeName( QString );

protected:
    bool event( QEvent* );
    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );
private:
	long TimeCount;

signals:
    void Closed( int );
    void KeyPress( QKeyEvent* );
    void KeyRelease( QKeyEvent* );	

};

#endif // EXTERNALTIMER_H
