/***************************************************************************
                          metro.h  -  description
                             -------------------
    begin                : Mon Aug 12 2002
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef METRONOME_H
#define METRONOME_H

#include <qvariant.h>
#include <qwidget.h>
#include <qpixmap.h>
#include "QLED.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QLabel;

class Metronome : public QWidget
{ 
    Q_OBJECT

public:
    Metronome( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~Metronome();

    QPixmap *LED;
    QPixmap *LEDoff;
	QPixmap *Spacer;

	QLED *LEDLabel;
	QLED *SpacerLabel;

	QLED *StartLED;
	QLED *MoveLED;

	QLED *StartSpacer;

    QFrame* Line;
    QLabel* TextMeter;
    QLabel* TextBPM;

	QLabel* WindowLabel;

	int UpdateMetro();	//make sure to check if there is only one led to toggle it
	int UpdateMeter( QString );	//adjust metro meter and call UpdateDisplay()
	void UpdateBPS( int );
	void ResetMetro( int ); // 0 total reset, 1 reset to start but continue
	void UpdateName( QString, QString ); //Window name and Label name
	void RepaintMetro();
	void SetImage( QString, int );

	int Status; //whether it is on or off
 
protected:
    QVBoxLayout* MetronomeLayout;
	QGridLayout* LEDLayout;
    QHBoxLayout* TextLayout;
	bool event( QEvent* );
    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );
private:
	int Timer; //counts clicks for the metro
	int BPS;	//beats per SECOND to compare with metro
	int LEDNum; //number of led's
	int LEDRow; //number of rows
	int CurrLED; //current LED to be litup
	int SpacerNum; //number of spacers
	int MaxWidth; //max horizontal width for the layout purposes
	QString Title;

    int oldW, oldH;

	int imgX;
	int imgY;
	bool Updating; 
  
	void DeleteDisplay();
	void CreateDisplayRow( int, int, int ); //create LED widgets

public slots:
    void ChangeStatus( int );
    void SetResizable( bool );

signals:
	void Closed( int );
	void MeterParseError( QString );
    void KeyPress( QKeyEvent* );
    void KeyRelease( QKeyEvent* );
};

#endif // METRONOME_H
