/***************************************************************************
                          qmidi.h  -  description
                             -------------------
    begin                : Wed Feb 5 2003
    copyright            : (C) 2003 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMIDI_H
#define QMIDI_H

#include <qthread.h>
#include <qwidget.h>

#include "stringevent.h"
#include "midievent.h"

/**
  *@author Ivica Bukvic
  */

class QMidi : public QObject, public QThread  {
  Q_OBJECT
public:
  QMidi(QWidget* parent = 0, const char* name = 0, WFlags fl = 0, QString port="/dev/midi" );
  ~QMidi();

  int Write( unsigned char );

  int GetCommand();
  int GetMessage_1();
  int GetMessage_2();

  bool MidiLog;
  bool GetStatus();

  int RetryOpen( QString );

private:
  bool status; //whether it is started or stopped

  int command;
  int message_1;
  int message_2;
  int numMidiObjs;

  int midi_fd;

  void run();

  MidiEvent *me;
  StringEvent *se;

  QWidget *ptr;

public slots:
  void ChangeStatus( bool );
};

#endif
