/***************************************************************************
                          lightevents.h  -  description
                             -------------------
    begin                : Wed Aug 14 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

void RTMix::UpdatePause()
{
	PauseCounter++;
	if ( PauseCounter == 100 )
	{
		PlayIndicator->setPixmap( imageRedon );
		//PlayIndicator->setPixmap( imageRedon );
	}
	if ( PauseCounter == 200 )
	{
		PauseCounter = 0;
		PlayIndicator->setPixmap( imageRedoff );
		//PlayIndicator->setPixmap( imageRedoff );
	}
}

void RTMix::UpdateCountdown()
{
	if ( CountdownCount - CountdownPtr->lightLength > 0 && CountdownPtr->light >= 3 )
	{
    	UpdateWarnDisplay();
	}
	if ( CountdownCount > 0 && CountdownPtr->light < 3 )
	{
     	UpdateWarnDisplay();
	}

	if ( CountdownCount >= 0 )	
	{
		UpdateLights(CountdownPtr, CountdownCount);
		CountdownCount--;
	}		
}

void RTMix::UpdateWarning()
{
	if ( WarningCount - WarningPtr->lightLength > 0 && WarningPtr->light >= 3 )
	{
    	UpdateWarnDisplay();
	}
	if ( WarningCount > 0 && WarningPtr->light < 3 )
	{
     	UpdateWarnDisplay();
	}

	if ( WarningCount >= 0 )
	{
		UpdateLights(WarningPtr, WarningCount);
		WarningCount--;
	}
}

void RTMix::UpdateLights( struct eventCue *EventPointer, long Length)
{
	//CASE 1 (Green lights up for a certain duration)
	if ( EventPointer->light == 1 )
	{
       if ( Length == EventPointer->lightLength )
		{
			//FIRST-TIME CALL
			WarnExecute->setPixmap( imageGreenon );
			WarnIndicator->setPixmap( imageYellowoff );
		}
		if ( Length == 0 )
		{
			WarnExecute->setPixmap( imageGreenoff );
		}
	}

	//CASE 2 (Yellow blinks)
	if ( EventPointer->light == 2 )
	{
		//TextInterface->append (" b " );
		if ( Length == EventPointer->lightLength )
		{
			//FIRST-TIME CALL
			WarnIndicator->setPixmap( imageYellowon );
			WarnExecute->setPixmap( imageGreenoff );
			WarnIndicatorBlinkStatus = 0;
		}
		if ( float(float(EventPointer->lightLength - Length) / float(EventPointer->blinkSpeed)) == int((EventPointer->lightLength - Length) / EventPointer->blinkSpeed) && Length > 0 && Length < EventPointer->lightLength && EventPointer->blinkSpeed != 0 )
		{
			//TextInterface->append(" a ");
			WarnIndicatorBlinkStatus++;
			if ( WarnIndicatorBlinkStatus == 1 )
			{
				WarnIndicatorBlinkStatus = -1;
				WarnIndicator->setPixmap( imageYellowoff );
			}
			if ( WarnIndicatorBlinkStatus == 0 )
			{
				WarnIndicator->setPixmap( imageYellowon );
			}
		}
		if ( Length == 0 )
		{
			WarnIndicator->setPixmap( imageYellowoff );
		}	
	}

	//CASE 3 (countdown setttings)
	if ( EventPointer->light == 3 )
	{
        if ( Length == EventPointer->countdown + EventPointer->lightLength )
		{
			//FIRST-TIME CALL
			//TextInterface->append (" c " );
			WarnIndicator->setPixmap( imageYellowon );
			WarnExecute->setPixmap( imageGreenoff );
			WarnIndicatorBlinkStatus = 0;
		}
		if ( EventPointer->blinkSpeed != 0 && float(float(EventPointer->prepLength - Length) / float(EventPointer->blinkSpeed)) == int((EventPointer->prepLength - Length) / EventPointer->blinkSpeed) && Length > 0 && (Length - EventPointer->lightLength) <= EventPointer->prepLength )
		{
			WarnIndicatorBlinkStatus++;
			if (WarnIndicatorBlinkStatus == 0 && Length > EventPointer->lightLength )
			{
				WarnIndicator->setPixmap( imageYellowon );
			}
			if (WarnIndicatorBlinkStatus == 1 )
			{
                WarnIndicatorBlinkStatus = -1;
				if ( EventPointer->prepLength == (Length - EventPointer->lightLength) && EventPointer->prepLength != EventPointer->countdown || (Length - EventPointer->lightLength) < EventPointer->prepLength )
				{
					WarnIndicator->setPixmap( imageYellowoff );
				}
				else
				{
                   	WarnIndicatorBlinkStatus = 0;
				}
			}
		}
		if ( Length == EventPointer->lightLength && EventPointer->lightLength != 0 )
		{
            WarnIndicator->setPixmap( imageYellowoff );
			WarnExecute->setPixmap( imageGreenon );
		}
		if ( Length == 0 )
		{
			WarnExecute->setPixmap( imageGreenoff );
		}	
	}

	//System Call for Countdown event
	if ( Length == 0 && EventPointer->light < 3  && EventPointer->ID == 2 || Length == EventPointer->lightLength && EventPointer->light >= 3 && EventPointer->ID == 2  )
	{
		if ( EventPointer->event != "none" )
		{
			system( EventPointer->event );
		}
	}
    Window1->InternalUpdate();
    Window2->InternalUpdate();
    Window3->InternalUpdate();
    Window4->InternalUpdate();
    LEDw->InternalUpdate();
}
