/***************************************************************************
                          rtmix-timedevents.h  -  description
                             -------------------
    begin                : Sat Aug 31 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "randfuncs.h"
#include "mathexpr.h"

void RTMix::UpdateMetros()
{
 	Metro1->UpdateMetro();
	Metro2->UpdateMetro();
	Metro3->UpdateMetro();
	Metro4->UpdateMetro();
}

void RTMix::UpdateLightEvents()
{
	long length;
	QString temp; //DEBUG

	if ( EventPtr != NULL )
	{
     	if ( EventPtr->light != 0 )
		{
         	if ( EventPtr->countdown > 0 )
			{
             	length = (EventPtr->countdown + EventPtr->lightLength) - (TimeCount - EventPtr->time);
			}
			else
			{
             	length = EventPtr->lightLength - (TimeCount - EventPtr->time);
			}
			//qDebug( "eventlength %i", length );
			if ( length == -1 )
			{
             	EventPtr = NULL;
			}
			else
			{
				UpdateLights( EventPtr, length );
			}
		}
	}

	if ( CountdownPtr != NULL )
	{
		UpdateCountdown();
	}

	if ( TextPtr != NULL )
	{
     	if ( TextPtr->light != 0 )
		{
         	if ( TextPtr->countdown > 0 )
			{
             	length = (TextPtr->countdown + TextPtr->lightLength) - (TimeCount - TextPtr->time);
			}
			else
			{
             	length = TextPtr->lightLength - (TimeCount - TextPtr->time);
			}
			if ( length < 0 )
			{
             	EventPtr = NULL;
			}
			else
			{
				UpdateLights( TextPtr, length );
			}			
		}
	}

	if ( CheckpointPtr != NULL )
	{
     	if ( CheckpointPtr->light != 0 )
		{
         	if ( CheckpointPtr->countdown > 0 )
			{
             	length = (CheckpointPtr->countdown + CheckpointPtr->lightLength) - (TimeCount - CheckpointPtr->time);
			}
			else
			{
             	length = CheckpointPtr->lightLength - (TimeCount - CheckpointPtr->time);
			}
			UpdateLights( CheckpointPtr, length );
		}
	}

	if ( ClearPtr != NULL )
	{
     	if ( ClearPtr->light != 0 )
		{
         	if ( ClearPtr->countdown > 0 )
			{
             	length = (ClearPtr->countdown + ClearPtr->lightLength) - (TimeCount - ClearPtr->time);
			}
			else
			{
             	length = ClearPtr->lightLength - (TimeCount - ClearPtr->time);
			}
			if ( length < 0 )
			{
             	EventPtr = NULL;
			}
			else
			{
				UpdateLights( ClearPtr, length );
			}			
		}
	}

	if ( WarningPtr != NULL )
	{
		UpdateWarning();
	}

	if ( MetroPtr != NULL )
	{
     	if ( MetroPtr->light != 0 )
		{
         	if ( MetroPtr->countdown > 0 )
			{
             	length = (MetroPtr->countdown + MetroPtr->lightLength) - (TimeCount - MetroPtr->time);
			}
			else
			{
             	length = MetroPtr->lightLength - (TimeCount - MetroPtr->time);
			}
			UpdateLights( MetroPtr, length );
		}
	}

	if ( JumpPtr != NULL )
	{
     	if ( JumpPtr->light != 0 )
		{
         	if ( JumpPtr->countdown > 0 )
			{
             	length = (JumpPtr->countdown + JumpPtr->lightLength) - (TimeCount - JumpPtr->time);
			}
			else
			{
             	length = JumpPtr->lightLength - (TimeCount - JumpPtr->time);
			}
			UpdateLights( JumpPtr, length );
		}
	}	

	if ( RandPtr != NULL )
	{
     	if ( RandPtr->light != 0 )
		{
         	if ( RandPtr->countdown > 0 )
			{
             	length = (RandPtr->countdown + RandPtr->lightLength) - (TimeCount - RandPtr->time);
			}
			else
			{
             	length = RandPtr->lightLength - (TimeCount - RandPtr->time);
			}
			UpdateLights( RandPtr, length );
		}
	}

	if ( ChangePtr != NULL )
	{
     	if ( ChangePtr->light != 0 )
		{
         	if ( ChangePtr->countdown > 0 )
			{
             	length = (ChangePtr->countdown + ChangePtr->lightLength) - (TimeCount - ChangePtr->time);
			}
			else
			{
             	length = ChangePtr->lightLength - (TimeCount - ChangePtr->time);
			}
			UpdateLights( ChangePtr, length );
		}
	}

	if ( RewPtr != NULL )
	{
     	if ( RewPtr->light != 0 )
		{
         	if ( RewPtr->countdown > 0 )
			{
             	length = (RewPtr->countdown + RewPtr->lightLength) - (TimeCount - RewPtr->time);
			}
			else
			{
             	length = RewPtr->lightLength - (TimeCount - RewPtr->time);
			}
			UpdateLights( RewPtr, length );
		}
	}
	if ( FfwPtr != NULL )
	{
     	if ( FfwPtr->light != 0 )
		{
         	if ( FfwPtr->countdown > 0 )
			{
             	length = (FfwPtr->countdown + FfwPtr->lightLength) - (TimeCount - FfwPtr->time);
			}
			else
			{
             	length = FfwPtr->lightLength - (TimeCount - FfwPtr->time);
			}
			UpdateLights( FfwPtr, length );
		}
	}
	if ( ToggleMetroPtr != NULL )
	{
     	if ( ToggleMetroPtr->light != 0 )
		{
         	if ( ToggleMetroPtr->countdown > 0 )
			{
             	length = (ToggleMetroPtr->countdown + ToggleMetroPtr->lightLength) - (TimeCount - ToggleMetroPtr->time);
			}
			else
			{
             	length = ToggleMetroPtr->lightLength - (TimeCount - ToggleMetroPtr->time);
			}
			UpdateLights( ToggleMetroPtr, length );
		}
	}
	if ( AssignPtr != NULL )
	{
     	if ( AssignPtr->light != 0 )
		{
         	if ( AssignPtr->countdown > 0 )
			{
             	length = (AssignPtr->countdown + AssignPtr->lightLength) - (TimeCount - AssignPtr->time);
			}
			else
			{
             	length = AssignPtr->lightLength - (TimeCount - AssignPtr->time);
			}
			UpdateLights( AssignPtr, length );
		}
	}
	if ( ToggleRTPtr != NULL )
	{
     	if ( ToggleRTPtr->light != 0 )
		{
         	if ( ToggleRTPtr->countdown > 0 )
			{
             	length = (ToggleRTPtr->countdown + ToggleRTPtr->lightLength) - (TimeCount - ToggleRTPtr->time);
			}
			else
			{
             	length = ToggleRTPtr->lightLength - (TimeCount - ToggleRTPtr->time);
			}
			UpdateLights( ToggleRTPtr, length );
		}
	}
	if ( ToggleNetPtr != NULL )
	{
     	if ( ToggleNetPtr->light != 0 )
		{
         	if ( ToggleNetPtr->countdown > 0 )
			{
             	length = (ToggleNetPtr->countdown + ToggleNetPtr->lightLength) - (TimeCount - ToggleNetPtr->time);
			}
			else
			{
             	length = ToggleNetPtr->lightLength - (TimeCount - ToggleNetPtr->time);
			}
			UpdateLights( ToggleNetPtr, length );
		}
	}
	if ( ToggleMIDIPtr != NULL )
	{
     	if ( ToggleMIDIPtr->light != 0 )
		{
         	if ( ToggleMIDIPtr->countdown > 0 )
			{
             	length = (ToggleMIDIPtr->countdown + ToggleMIDIPtr->lightLength) - (TimeCount - ToggleMIDIPtr->time);
			}
			else
			{
             	length = ToggleMIDIPtr->lightLength - (TimeCount - ToggleMIDIPtr->time);
			}
			UpdateLights( ToggleMIDIPtr, length );
		}
	}
	if ( PlayPtr != NULL )
	{
     	if ( PlayPtr->light != 0 )
		{
         	if ( PlayPtr->countdown > 0 )
			{
             	length = (PlayPtr->countdown + PlayPtr->lightLength) - (TimeCount - PlayPtr->time);
			}
			else
			{
             	length = PlayPtr->lightLength - (TimeCount - PlayPtr->time);
			}
			UpdateLights( PlayPtr, length );
		}
	}
}












//DO THE INTERPRETER OF THE CUE WHICH IS GOING TO BE CALLED BY MAIN TIMER LOOP TO EXECUTE COMMANDS
int RTMix::InterpretCue( struct eventCue *Ptr )
{
	QString temp, temp2, stringColor, insert, ModEvent, ModText, tmp_1;
	int position, endposition, val;
	long tempColor;
	struct eventCue *tempPtr;
	struct eventCue *current;
	bool ok;
	QString filterList, filter;
	int filterCheck, length;

/*
	if ( Ptr->time >= 0 && Ptr->absat == 0 && Ptr == Move )
	{
		FollowMove = Ptr;
	}
	else
	{
*/
     FollowMove = Move;
	//}

	if ( Ptr == Start ) {
		return 0;
	}

    //qDebug( "ID = %d", Ptr->ID );

	if ( Ptr->happen < Ptr->chance || Ptr->chance == 10000 || Ptr->chance == 0 && Ptr->happen == 0 )
	{
     	//THIS EVENT IS NOT HAPPENING AT THIS TIME
        if (Verbose)
            Error ( " -- The event is not happening due to reassigned probability values.\n");
		return 0;
	}

	if ( Ptr->ID == 0 )
	{
       if (Verbose)
            Error ( " -- The event is not happening due to reassigned ID = 0 value.\n" );
		return 0;
	}

	if ( Ptr->netAddress > -2 )
	{
     	if ( Ptr->netAddress == -1 )
		{
         	//Global network send
			SendGlobalEvent( Ptr );
		}
		if ( Ptr->netAddress >= 0 )
		{
         	//Single network send
			SendSingleEvent( Ptr );
			return 0;
		}
	}
    T->ToggleARt( TRUE );

    
    //FIGURE OUT LIGHT EVENTS FOR EXTERNAL WIDGETS
    if ( Ptr->countdown > 0 )
    {
        length = (Ptr->countdown + Ptr->lightLength) - (TimeCount - Ptr->time);
    }
    else
    {
        length = Ptr->lightLength - (TimeCount - Ptr->time);
    }
	//CASE 4-7 CUSTOM WARNING_WINDOW LIGHTS
	if ( Ptr->light == 4 )
	{
        Window1->UpdateDisplay( Ptr, length );
	}
	if ( Ptr->light == 5 )
	{
        Window2->UpdateDisplay( Ptr, length );
	}
	if ( Ptr->light == 6 )
	{
        Window3->UpdateDisplay( Ptr, length );
	}
	if ( Ptr->light == 7 )
	{
        Window4->UpdateDisplay( Ptr, length );
	}

	//CASE 8-13 CUSTOM LIGHTS IN A SINGLE WINDOW
	if ( Ptr->light > 7 )
	{
     	LEDw->UpdateDisplay( Ptr, length );
	}


	//PARSE SAY INFORMATION  
	if ( Ptr->text != "none" )
	{
        ModText = Ptr->text;
        position = 0;
        //First let's see if there are any numeric substitutions from the storage var's
        if ( ModText.find("v[", 0 ) != -1 )
        {
            while ( position != -1 )
            {
                val = 0;
                position = ModText.find( "v[", position );
                if ( position != -1 )
                {
                    endposition = ModText.find( "]", position + 2 );
                    if ( endposition != -1 )
                    {
                        temp = ModText.mid( position + 2, endposition - (position + 2) );
                        //qDebug( temp );
                        val = temp.toInt( &ok, 10 );

                        if ( !ok )
                        {
                            Error( " -- WARNING: encountered problems while parsing the v[<num>] value of the 'say' entry. Value contained inside is not a number. Ignoring the variable substitution in the 'say' parameter...\n" );
                            //return -1;
                        }
                        else if ( ok && val < 0 || ok && val > MAXVARS )
                        {
                            Error( " -- WARNING: encountered problems while parsing the v[<num>] value of the 'say' entry: value outside allowed range (0-" + tmp_1.setNum(MAXVARS) + "). Ignoring the variable substitution in the 'say' parameter...\n" );
                            //return -1;
                        }
                        else
                        {
                            if ( position >= 0 )
                            {
                                ModText.replace( position , endposition + 1 - position, insert.setNum( RandomNum[val] ) );
                            }
                        }
                    }
                    else
                    {
                        Error( " -- WARNING: encountered problems while parsing the v[<num>] value of the 'say' entry. No corresponding ']' found...\n" );
                    }
                }
            }
        }       
		position = 0;
		tempColor = 676767; //originally 1222221
		temp = TextInterface->text();
		while ( temp.find( "\"#", position ) != -1 && tempColor > 0 )
		{
        	position =  temp.find( "\"#", position ) + 2;
			tempColor = tempColor - 141414; //originally 222222
			if ( tempColor < 0 )
			{
             	temp.remove( position + 7, temp.length() - (position + 7) );
			}
			else
			{
				temp.replace( position, 6, stringColor.setNum( tempColor, 10 ) );
			}
		}
		if ( Ptr->color == "0" )
		{
			//qDebug( Ptr->text);
          position =  ModText.find( "\"#", 0 ) + 2;
 			ModText.replace( position, 6, DefaultTextInterfaceColor );
			//qDebug( Ptr->text );			
         }
		//qDebug( Ptr->text + " " + DefaultTextInterfaceColor + " " + Ptr->color );
		TextInterface->setText(ModText + "<br>" + temp);
	}
	if ( Ptr->ID == 1 )
    {
        //EVENT
        EventPtr = Ptr;
        if ( Ptr->event != "none" )
        {
            //CHECK FOR ANY KIND OF RT PARAM IN THE STATEMENT
            //v[ ] entries drawing from the 256 storable variables

            ModEvent = Ptr->event;
            //ChangePtr = Ptr;
            position = 0;
            endposition = 0;
            //qDebug( "RT " + ModEvent );

            while ( position != -1 )
            {
                position = ModEvent.find( "v[", position );
                if ( position != -1 )
                {
                    //qDebug("RT Found v[");
                    endposition = ModEvent.find( "]", position + 2 );
                    temp = ModEvent.mid( position + 2, endposition - (position + 2) );
                    //qDebug( "RT v[] = " + temp );
                    val = temp.toInt( &ok, 10 );
                    if ( !ok )
                    {
                        Error( " -- Error parsing <num> in the v[<num>] value of the 'event' entry. Ignoring the call...\n" );
                    }
                    else
                    {
                        //temp = Ptr->event;
                        //qDebug ( "position %i", position );
                        //qDebug ( "endposition %i", endposition );
                        //qDebug ( "temp:" + temp );
                        if ( position >= 0 )
                        {
                            ModEvent.replace( position , endposition + 1 - position, insert.setNum( RandomNum[val] ) );
                            //qDebug( temp );
                        }
                    }
                }
            }

            position = 0;
            //Now check for the midi[ ] argument (for the feed for the real-time MIDI input)
            while ( position != -1 )
            {
                position = ModEvent.find( "midi[", position );
                if ( position != -1 )
                {
                    //qDebug("RT Found midi[");
                    endposition = ModEvent.find( "]", position + 5 );
                    temp = ModEvent.mid( position + 5, endposition - (position + 5) );
                    //qDebug( "RT " + temp );
                    val = temp.toInt( &ok, 10 );
                    if ( !ok )
                    {
                        Error( " -- Error parsing the midi[<num>] value of the 'event' entry. Ignoring the call...\n" );
                    }
                    else if ( ok && val > 2 || ok && val < 0 )
                    {
                        Error( " -- Error parsing the midi[<num>] value of the 'event' entry: value out of range (0-2). Ignoring the call...\n" );
                    }
                    else if ( ok && val >= 0 && val <= 2 )
                    {
                        //temp = Ptr->event;
                        //qDebug ( "position %i", position );
                        //qDebug ( "endposition %i", endposition );
                        //qDebug ( "temp:" + temp );
                        //qDebug ( "val = %d", val );
                        if ( position >= 0 )
                        {
                            switch( val )
                            {
                                case 0:
                                    ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_1 ) );
                                    break;
                                case 1:
                                    ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_2 ) );
                                    break;
                                case 2:
                                    ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_3 ) );
                                    break;
                            }
                            //qDebug( ModEvent );
                        }
                    }
                }
            }
           // qDebug ( ModEvent );

            //CHECK IF THIS IS MIDI OR OSC EVENT
            if ( ModEvent.lower().find( "osc:", 0 ) != -1 )
            {
                //qDebug( "RT Found osc:" );
                //THIS IS OSC TO BE SENT
                T->ToggleAOsc( TRUE );
                QString OSCHost, TmpEvent, TmpMessage, TmpName;
                char* OSCMessage;
                bool OSCTags;
                int OSCPort;
                int OSCParams[2];
                TmpEvent = ModEvent.section(":", 1);
                TmpEvent = TmpEvent.simplifyWhiteSpace();

                /*
                if ( Ptr->OSCPtr != NULL )
                {
                    delete Ptr->OSCPtr;
                    Ptr->OSCPtr = NULL;
                }
                */
                
                OSCHost = TmpEvent.section(",", 0,0);
                //qDebug ( "RT host " + OSCHost );
                OSCPort = TmpEvent.section(",", 1,1).toInt( NULL, 10 ); //stuff has been checked so no need to recheck it
                //qDebug( "RT port %d", OSCPort );
                OSCTags = TmpEvent.section(",", 2,2).toInt( NULL, 10 );
                //qDebug( "RT tags %d", OSCTags );
                TmpMessage = TmpEvent.section(",",3,3);
                TmpMessage = TmpMessage.simplifyWhiteSpace();
                //qDebug( "RT message " + TmpMessage );
                OSCMessage = const_cast<char *>( TmpMessage.latin1() );
                //qDebug( OSCMessage );
                OSCParams[0] = TmpEvent.section(",",4,4).toInt(NULL);
                OSCParams[1] = TmpEvent.section(",",5,5).toInt(NULL);
                //qDebug( "RT params %d %d", OSCParams[0], OSCParams[1] );
                Ptr->OSCPtr->WriteMessage( OSCMessage, OSCParams[0], OSCParams[1] );
                //Ptr->OSCPtr = new OSCEvent( this, TmpName.setNum( (-(Ptr->time) - 999), 10 ) , 0, OSCHost, OSCPort, OSCTags, OSCMessage, OSCParams[0], OSCParams[1] );
                //qDebug("Main loop deleting OSCPtr");
                //delete Ptr->OSCPtr; //get rid of the class once the work has been done
                //qDebug("Main loop deleted");
                //Ptr->OSCPtr = NULL;
                //qDebug("Pointer = null");
            }
            //CHECK IF THIS IS MIDI OR OSC EVENT
            if ( ModEvent.lower().find( "osccustom:", 0 ) != -1 )
            {
                //qDebug( "RT Found osccustom:" );
                T->ToggleAOsc( TRUE );
                //THIS IS OSC CUSTOM TO BE SENT
                QString OSCHost, TmpEvent, TmpMessage, TmpName;
                char* OSCMessage;
                bool OSCTags;
                int OSCPort;
                TmpEvent = ModEvent.section(":", 1);
                TmpEvent = TmpEvent.simplifyWhiteSpace();

                /*
                if ( Ptr->OSCPtr != NULL )
                {
                    delete Ptr->OSCPtr;
                    Ptr->OSCPtr = NULL;
                }
                */
                
                OSCHost = TmpEvent.section(",", 0,0);
                //qDebug ( "RT host " + OSCHost );
                OSCPort = TmpEvent.section(",", 1,1).toInt( NULL, 10 ); //stuff has been checked so no need to recheck it
                //qDebug( "RT port %d", OSCPort );
                OSCTags = TmpEvent.section(",", 2,2).toInt( NULL, 10 );
                //qDebug( "RT tags %d", OSCTags );
                TmpMessage = TmpEvent.section(",",3);
                TmpMessage = TmpMessage.simplifyWhiteSpace();
                //qDebug( "RT message " + TmpMessage );
                OSCMessage = const_cast<char *>( TmpMessage.latin1() );
                //qDebug( "OSC custom:" );
                //qDebug( OSCMessage );
                //using low_a = -100 as an identifier for the osccustom
                Ptr->OSCPtr->WriteCustomMessage( OSCMessage );
                //qDebug( "OSCCUSTOM" );
                //Ptr->OSCPtr = new OSCEvent( this, TmpName.setNum( (-(Ptr->time) - 999), 10 ) , 0, OSCHost, OSCPort, OSCTags, OSCMessage, -100 );
                //delete Ptr->OSCPtr; //get rid of the class once the work has been done
                //Ptr->OSCPtr = NULL;
            }
            else if ( Ptr->event.lower().find( "midisend:", 0 ) != -1 )
            {
                //qDebug("Found midisend:");
                T->ToggleAMidi( TRUE );
                //THIS IS MIDI TO BE SENT
                QString TmpEvent;
                int i, count;

                TmpEvent = ModEvent.section(":", 1);
                TmpEvent = TmpEvent.simplifyWhiteSpace();
                i = 0;
                count = 0;

                while ( i != -1 )
                {
                    i = TmpEvent.find(",", i+1 );
                    if ( i != -1)
                    {
                        count++;
                    }
                }
                for ( i=0; i <= count; i++ )
                {
                    //qDebug("Writing: %d" + TmpEvent.section(",", i,i) );
                    Midi->Write( (unsigned char)TmpEvent.section(",", i,i).toUInt( NULL, 10 ) );
                }
            }
            else
            {
                //qDebug("Regular event");
                //FILTER EVENT AND PRODUCE WARNING
                filterList = S->GetFilter();
                filter = " ";
                filterCheck = 0;
                while ( filter != "" )
                {
                    filter = filterList.section(",", filterCheck, filterCheck );
                    //qDebug( filter );
                    if ( ModEvent.contains( filter ) > 0 && filter != "" )
                    {
                        Error( " -- Error: your system-call event contains '" + filter + "' filtered event. Ignoring the call..." );
                        return 0;
                    }
                    filterCheck++;
                }  
                system ( ModEvent );
            }
            //qDebug( "Event %i", Ptr->time );
        }
	}
	if ( Ptr->ID == 2 ) {
		//COUNTDOWN
		//WarnEvent = Ptr->event;
		if ( Ptr->light != 0 )
		{
        	if ( Ptr->light >= 3 )
			{
             	CountdownCount = Ptr->countdown + Ptr->lightLength;
			}
			else
			{
             	CountdownCount = Ptr->countdown;
			} 	
		}  
		CountdownPtr = Ptr;
		AdjustWarnTimer( CountdownPtr );
		if ( CountdownPtr->light > 3 )
		{
         	AdjustOtherTimers( CountdownPtr );
		}
	}
	if ( Ptr->ID == 3 ) {
		TextPtr = Ptr;
		//qDebug( "Text %i", Ptr->time );
		//TEXT
	}
	if ( Ptr->ID == 4 ) {
		CheckpointPtr = Ptr;
        //qDebug( "b" );
		//CHECKPOINT
	}
	if ( Ptr->ID == 5 ) {
		//PAUSE
		PauseButton->setOn( true );
		Pause( NULL );
	}
	if ( Ptr->ID == 6 ) {
		//STOP
		Stop( NULL );
	}
	if (Ptr->ID == 7 ) {
		//CLEAR
		ClearPtr = Ptr;
		TextInterface->setText("");
	}
	if (Ptr->ID == 8 )
	{
     	//WARNING
		WarningPtr = Ptr;
		PlaybackStatus = 7;
		if ( Ptr->light != 0 )
		{
        	if ( Ptr->light >= 3 )
			{
             	WarningCount = Ptr->countdown + Ptr->lightLength;
			}
			else
			{
             	WarningCount = Ptr->lightLength;
			} 	
		}
		WarningPtr = Ptr;
		AdjustWarnTimer( WarningPtr );
		if ( Ptr->event != "none" )
		{
			system( Ptr->event );
		}
	}
	if ( Ptr->ID == 9 )
	{
		//METRONOME
		MetroPtr = Ptr;
        //qDebug( Ptr->event );
        //qDebug( "%d" , Ptr->bpm );
		if ( Ptr->type == 1 )
		{
         	Metro1->UpdateBPS( Ptr->bpm );
			Metro1->UpdateMeter( Ptr->event );
		}
		if ( Ptr->type == 2 )
		{
         	Metro2->UpdateBPS( Ptr->bpm );
			Metro2->UpdateMeter( Ptr->event );
		}
		if ( Ptr->type == 3 )
		{
         	Metro3->UpdateBPS( Ptr->bpm );
			Metro3->UpdateMeter( Ptr->event );
		}
		if ( Ptr->type == 4 )
		{
         	Metro4->UpdateBPS( Ptr->bpm );
			Metro4->UpdateMeter( Ptr->event );
		}
	}
	if ( Ptr->ID == 10 )
	{
		//JUMP
		JumpPtr = Ptr;
		position = 0;
		if ( Ptr->event == "0" )
		{
         	//RELATIVE
			//qDebug( "Relative" );
           //if ( PlaybackStatus <= 3 )
           //{
           //    position--; //fix for the jumps when the timer is not on
           //}
			if ( Ptr->bpm < 0 )
			{
				tempPtr = Move;
				//BACK
				while ( tempPtr != Start && position != JumpPtr->bpm )
				{
					//qDebug( "1 %i %i", position, JumpPtr->bpm );
                	if ( tempPtr->ID == 4 && tempPtr->absat == 0 ) { position--; }
					if ( position != JumpPtr->bpm ) {
						tempPtr = tempPtr->prev;
					}	
				}
				if ( tempPtr == Start && position > JumpPtr->bpm )
				{
                 if (Verbose)
                    Error ( " -- WARNING: Relative jump out of bounds, returning to beginning.\n");
				}
				if ( tempPtr != FollowMove ) {
                  Move = tempPtr;
                  ClearContinuousEvents( 1 );
                  TimeCount = tempPtr->time;
                  AdjustTimer( NULL );
                  E->SetTimeCount( TimeCount );
                  FollowMove = NULL;
                  /*
                  if ( Ptr->time >= -10 || PlaybackStatus <= 3 )
                  {
                      InterpretCue( Move );
                      if ( Move->next != NULL )
                      {
                          Move = Move->next;
                      }
                  }
                  */
					//InterpretCue( Move );
				}
			}
			else if ( Ptr->bpm > 0 )
			{
             	//FORWARD
				current = NULL;
				tempPtr = Move;
				while ( tempPtr != End && position != JumpPtr->bpm )
				{
					//qDebug( "2" );
                 	if ( tempPtr->ID == 4 && tempPtr->absat == 0 )
					{
						position++;
						current = tempPtr;
                      //qDebug("Found one %d", current->time );
					}
					if ( position != JumpPtr->bpm ) {
						tempPtr = tempPtr->next;
					}
				}
				if ( tempPtr == End && position != JumpPtr->bpm && tempPtr->time > TimeCount )
				{
		         	if ( tempPtr->ID == 4 && tempPtr->absat == 0 )
					{
						position++;
						current = tempPtr;
                      //qDebug("Found two %d", current->time );
					}
				}
				if ( tempPtr == End && position != JumpPtr->bpm )
				{
                  if (Verbose)
                      Error ( " -- WARNING: Relative jump out of bounds, trying to move to last existing checkpoint...");
					if ( current == NULL )
					{
                     	Error ( " -- WARNING: jump failed because no checkpoints found between existing position and the last event. Ignoring Jump event...\n");
                        return 0;
					}
					//else
					//{
                      //Move = current;                     
						   //Error ( "SUCCESS.\n" );
					//}
				}
				if ( current != NULL && current->time >= TimeCount || current != NULL && current == FollowMove && current == End )
				{
                  //qDebug("Updating");
                  Move = current;
                  ClearContinuousEvents( 1 );
                  TimeCount = Move->time;
                  AdjustTimer( NULL );
                  E->SetTimeCount( TimeCount );
                  FollowMove = NULL;
                  /*
                  if ( Ptr->time >= -10 || PlaybackStatus <= 3 )
                  {
                      InterpretCue( Move );
                      if ( Move->next != NULL )
                      {
                          Move = Move->next;
                      }
                  }
                  */
				}
			}
			else if ( Ptr->bpm == 0 )
			{
				//qDebug( "3" );
               if (Verbose)
                  Error ( " -- WARNING: Relative jump ignored since the jump value is 0.\n");
			}
		}
		else
		{
         	//ABSOLUTE
			//qDebug( "Absolute Jump" );
			tempPtr = Start;
			position = 0;
			while ( tempPtr != End && position != JumpPtr->bpm )
			{
				if ( tempPtr->ID == 4 && tempPtr->absat == 0 )
				{
                 	position++;
                  //qDebug("UP %d", tempPtr->time );
				}
				if ( position != JumpPtr->bpm ) {
					tempPtr = tempPtr->next;
				}
			}
			if ( tempPtr == End && position != JumpPtr->bpm )
			{
	         		if ( tempPtr->ID == 4 && tempPtr->absat == 0 )
                  {
                      //qDebug("UP %d", tempPtr->time );
                      position++;
                  }
			}
			if ( position == JumpPtr->bpm )
			{
				//qDebug ( "%i, %i, %i", TimeCount, Move->ID, Move->bpm );
				if ( position == 0 )
				{
                 if (Verbose)
                   Error( " -- Jumping back to beginning.\n" );
				}
				Move = tempPtr;
				ClearContinuousEvents( 1 );
        			TimeCount = long( Move->time );
				//qDebug ( "%i, %i, %i, m->n->t %i", TimeCount, Move->ID, Move->bpm, Move->next->time );
        			AdjustTimer( NULL );
        			E->SetTimeCount( TimeCount );
                  FollowMove = NULL;
                  //qDebug( "a" );
                  //qDebug( "%d", Move->ID );
                  /*
                  if ( Ptr->time >= -10 || PlaybackStatus <= 3 )
                  {
                      InterpretCue( Move );
                      while ( Move->next != NULL )
                      {
                          Move = Move->next;
                      }
                  }
                  */
/*
				InterpretCue( Move );
				//qDebug( "Starting time %i", Move->time );
				while ( Move->next != NULL && Move->next->time == Move->time )
				{
					Move = Move->next;
					InterpretCue( Move );
					//qDebug( "Continuing time %i", Move->time );
				}
				if ( Move->next != NULL && Move->time <= TimeCount )
				{
					Move = Move->next;
				}
				qDebug( "Continuing time %i", Move->time );
*/
			}
			else
			{
               Move = FollowMove;
               Error ( " -- WARNING: Absolute jump impossible since there is not that many checkpoints specified.\n");
			}
		}
	}
	if ( Ptr->ID == 11 )
	{
		//RANDOMIZE
		float val;
		QString temp3, temp4, temp5;
		RandPtr = Ptr;

		if ( Ptr->method == 0 ) {
			val = rrand( RandSeed );
		}
		if ( Ptr->method == 1 ) {
			val = brrand( RandSeed );
		}
		if ( Ptr->method == 2 ) {
			val = gaussian( RandSeed );
		}
		if ( Ptr->method == 3 ) {
			val = cauchy( RandSeed );
		}
		if ( Ptr->method == 4 ) {
			val = linlo( RandSeed );
		}
		if ( Ptr->method == 5 ) {
			val = linhi( RandSeed );
		}
		if ( Ptr->method == 6 ) {
			val = triangle( RandSeed );
		}
		//qDebug( "%f", val );
		if ( Ptr->type > 0 ) {
          //qDebug( "%g %d", val, Ptr->type );
          val = int(val * Ptr->type );
           //qDebug( "%g", val );
		}
		RandomNum[Ptr->bpm] = val;
		Error ( " -- method=" + temp2.setNum( Ptr->method, 10 ) + ", type=" + temp5.setNum( Ptr->type, 10 ) + " => RANDOM[" + temp3.setNum( Ptr->bpm, 10 ) + "]=" + temp4.setNum( val ) + ".\n" );
		RandSeed = RandSeed*1103515245 + 12345 >>16 & 077777;
	}
    if ( Ptr->ID == 12 )
    {
        //CHANGE
        ChangePtr = Ptr;
        position = 0;
        endposition = 0;
        ModEvent = Ptr->event;

        //Find v[] parameter (if there is one)
        while ( position != -1 )
        {
            position = ModEvent.find( "v[", position );
            if ( position != -1 )
            {
                endposition = ModEvent.find( "]", position + 2 );
                temp = ModEvent.mid( position + 2, endposition - (position + 2) );
                //qDebug( temp );
                val = temp.toInt( &ok, 10 );

                if ( !ok )
                {
                    Error( " -- Error parsing the v[<num>] value of the 'func' entry. Ignoring the call...\n" );
                    return -1;
                }
                else if ( ok && val < 0 || ok && val > 255 )
                {
                    Error( " -- Error parsing the v[<num>] value of the 'func' entry: value outside allowed range (0-255). Ignoring the call...\n" );
                    return -1;
                }
                else
                {
                    if ( position >= 0 )
                    {
                        ModEvent.replace( position , endposition + 1 - position, insert.setNum( RandomNum[val] ) );
                    }
                }
            }
            if ( position >= 0 ) { position++; }
        }

        position = 0;

        //Find MIDI parameter
        while ( position != -1 )
        {
            position = ModEvent.find( "midi[", position );
            if ( position != -1 )
            {
                if ( Ptr->accel.find("midi",0) == -1 )
                {
                    Error ( " -- Error parsing the midi[ ] value found in the event statement, since there is no Midi accelerator present to read value from. Ignoring the call...\n" );
                    return -1;
                }
                endposition = ModEvent.find( "]", position );
                if ( endposition == -1 )
                {
                    Error ( " -- Error parsing the midi[ ] value: no closing ']' for the midi[<num>] variable found in the given event. Ignoring the call...\n" );
                    return -1;
                }

                val = ModEvent.mid( position + 5 , endposition - (position + 5) ).toInt( &ok, 10 );
                if ( !ok )
                {
                    Error ( " -- Error parsing the midi[ ] value: variable is not a number. Ignoring the call...\n" );
                    return -1;
                }
                else if ( ok && val < 0 || ok && val > 2 )
                {
                    Error ( " -- Error parsing the midi[ ] value: variable is outside range of 0-2. Ignoring the call...\n" );
                    return -1;
                }
                else
                {
                    switch( val )
                    {
                        case 0:
                            ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_1 ) );
                            break;
                        case 1:
                            ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_2 ) );
                            break;
                        case 2:
                            ModEvent.replace( position , endposition + 1 - position, insert.setNum( midi_3 ) );
                            break;
                    }
                }
            }
            if ( position >= 0 ) { position++; }
        }
        //qDebug( temp );
        //qDebug( "%i, %i", position, endposition );

        //char expr[ 500 ] = temp;
        PROperation pop=new ROperation ( ModEvent );
        insert = pop->Expr();
        if ( insert.find( "Error", 0 ) == -1 )
        {
            //qDebug ( "%G, dest ID %i", pop->Val(), Dest->ID );
            position = 0;
            if ( Ptr->var.find( "v[",0 ) != -1 )
            {
                //this is being assigned to a variable
                //qDebug( "%d", pop->Val() );
                val = 0;
                position = Ptr->var.find( "v[", position );
                endposition = Ptr->var.find( "]", position + 2 );
                temp = Ptr->var.mid( position + 2, endposition - (position + 2) );
                //qDebug( temp );
                val = temp.toInt( &ok, 10 );

                if ( !ok )
                {
                    Error( " -- Error parsing the v[<num>] value of the 'store' entry. Ignoring the call...\n" );
                    return -1;
                }
                else if ( ok && val < 0 || ok && val > 255 )
                {
                    Error( " -- Error parsing the v[<num>] value of the 'store' entry: value outside allowed range (0-255). Ignoring the call...\n" );
                    return -1;
                }
                else
                {
                    if ( position >= 0 )
                    {
                        RandomNum[val] = pop->Val();
                        delete pop;
                        Error ( " -- CHANGE to var[" + temp.setNum( val, 10 ) + "]=" + temp2.setNum( RandomNum[val] ) + ".\n" );	
                    }
                }              
            }
            else
            {
                //this is going to one of the following events
                position = AssignValue ( Ptr, pop->Val() );
                delete pop;
                if ( position == -1 )
                {
                    Error ( " -- Error: requested value '" + Ptr->var + "' is not a part of the destination event. Ignoring the call...\n" );
                }
                if ( position == -2 )
                {
                    Error ( " -- Error: requested value '" + Ptr->var + "' is not applicable to the destination event. Ignoring the call...\n" );
                }
                if ( position == -3 )
                {
                    Error ( " -- Error: the destination real-time event '" + Ptr->var + "' does not exist. Ignoring the call...\n" );
                }
            }            
        }
        else
        {
            //qDebug ( "%G", pop->Val() );
            Error ( " -- Error: 'func' contains invalid values and cannot be calculated. Ignoring the call...\n" );
        }
    }
    
	if ( Ptr->ID == 13 )
	{
     	//SEED
		SeedPtr = Ptr;
		if ( Ptr->amt == 0 )
		{
         	RandSeed = long( tsrand() );
		}
		else
		{
         	RandSeed = long( Ptr->amt );
		}
		Error ( " -- SEED = " + temp.setNum( RandSeed, 10 ) + ".\n" );
	}
	if ( Ptr->ID == 14 )
	{
     	//REW
		RewPtr = Ptr;
		position = 0;
 		while ( Ptr != Start && position != RewPtr->bpm )
 		{
             if ( Ptr->ID == 4 ) { position++; }
 			if ( position != RewPtr->bpm ) {
 				Ptr = Ptr->prev;
 			}	
 		}
 		if ( Ptr == Start && position < RewPtr->bpm )
 		{
 			Error ( " -- WARNING: REW call out of bounds, returning to beginning.\n");
 		}
 		if ( Ptr != FollowMove ) {
			Move = Ptr;
			//qDebug( Ptr->text + " %i", Ptr->time );
     		ClearContinuousEvents( 1 );
     		TimeCount = Ptr->time;
     		AdjustTimer( NULL );
     		E->SetTimeCount( TimeCount );
			//InterpretCue( Move );
 		}
	}
	if ( Ptr->ID == 15 )
	{
     	//FFWD
		tempPtr = NULL;
		FfwPtr = Ptr;
		position = 0;
		while ( Ptr != End && position != FfwPtr->bpm )
		{
             if ( Ptr->ID == 4 )
			{
				position++;
				tempPtr = Ptr;
			}
			if ( position != FfwPtr->bpm ) {
				Ptr = Ptr->next;
			}
		}
		if ( Ptr == End && position != FfwPtr->bpm )
		{
         	if ( Ptr->ID == 4 ) { position++; }
		}
		if ( Ptr == End && position != FfwPtr->bpm )
		{
			Error ( " -- WARNING: FFW call out of bounds, trying to move to last existing checkpoint...");
			if ( tempPtr == NULL )
			{
				Error ( "Error: FFW failed -- no checkpoints found between existing position and the last event. Ignoring FFW call.\n");
			}
			else
			{
                 Ptr = tempPtr;
				  //Error ( " SUCCESS.\n" );
			}
		}
		if ( Ptr != FollowMove )
		{
			Move = Ptr;
    			ClearContinuousEvents( 1 );
    			TimeCount = Ptr->time;
    			AdjustTimer( NULL );
    			E->SetTimeCount( TimeCount );
			//InterpretCue( Move );
		}
	}	
	if ( Ptr->ID == 16 )
	{
		//TOGGLE METRO
     	ToggleMetroPtr = Ptr;
		MetroPtr = Ptr;
		if ( Ptr->type == 1 )
		{
         	if ( Ptr->bpm == 0 ) {
			 	Metro1->ResetMetro( 0 );
			}
         	if ( Ptr->bpm == 1 ) {
			 	Metro1->ChangeStatus( 0 );
			}
         	if ( Ptr->bpm == 2 ) {
				Metro1->Status = 1;
			 	Metro1->ResetMetro( 1 );
			}
         	if ( Ptr->bpm == 3 ) {
			 	Metro1->ChangeStatus( 1 );
			}
		}
		if ( Ptr->type == 2 )
		{
         	if ( Ptr->bpm == 0 ) {
			 	Metro2->ResetMetro( 0 );
			}
         	if ( Ptr->bpm == 1 ) {
			 	Metro2->ChangeStatus( 0 );
			}
         	if ( Ptr->bpm == 2 ) {
				Metro2->ChangeStatus( 1 );
			 	Metro2->ResetMetro( 1 );
			}
         	if ( Ptr->bpm == 3 ) {
			 	Metro2->ChangeStatus( 1 );
			}
		}
		if ( Ptr->type == 3 )
		{
         	if ( Ptr->bpm == 0 ) {
			 	Metro3->ResetMetro( 0 );
			}
         	if ( Ptr->bpm == 1 ) {
			 	Metro3->ChangeStatus( 0 );
			}
         	if ( Ptr->bpm == 2 ) {
				Metro3->ChangeStatus( 1 );
			 	Metro3->ResetMetro( 1 );
			}
         	if ( Ptr->bpm == 3 ) {
			 	Metro3->ChangeStatus( 1 );
			}
		}
		if ( Ptr->type == 4 )
		{
         	if ( Ptr->bpm == 0 ) {
			 	Metro4->ResetMetro( 0 );
			}
         	if ( Ptr->bpm == 1 ) {
			 	Metro4->ChangeStatus( 0 );
			}
         	if ( Ptr->bpm == 2 ) {
				Metro4->Status = 1;
			 	Metro4->ResetMetro( 1 );
			}
         	if ( Ptr->bpm == 3 ) {
			 	Metro4->ChangeStatus( 1 );
			}
		}
	}
	if ( Ptr->ID == 17 )
	{
     	//ASSIGN
		AssignPtr = Ptr;
		RandomNum[ Ptr->bpm ] = Ptr->amt;
		Error ( " -- ASSIGN to var[" + temp.setNum( Ptr->bpm, 10 ) + "] = " + temp2.setNum( Ptr->amt ) + ".\n" );		
	}
	if ( Ptr->ID == 18 )
	{
     	//TOGGLERT
		ToggleRTPtr = Ptr;
		if ( Ptr->bpm == 1 )
		{
			Error ( " ++ Starting real-time event monitoring...\n" );
			RTEventButton->setOn( TRUE );
		}
		else
		{
         	Error ( " ++ Stopping real-time event monitoring...\n" );
			RTEventButton->setOn( FALSE );
		}		
	}
	//19 needs no interpreting since it is done at compile-time
	if ( Ptr->ID == 20 )
	{
     	//TOGGLENET
		ToggleNetPtr = Ptr;
		ToggleNetwork( Ptr->type, bool( Ptr->bpm ) );
	}
	if ( Ptr->ID == 21 )
	{
     	//TOGGLEMIDI
		ToggleMIDIPtr = Ptr;
		if ( Ptr->bpm == 1 )
		{
            //Error ( " -- Starting real-time MIDI monitoring...\n" );
            if ( MIDIEventButton->isEnabled() )
            {
                MIDIEventButton->setOn( TRUE );    //TODO: make a midi-toggle button
            }
            else
            {
                //Error ( " -- WARNING: unable to start MIDI monitoring due to fact that the real-time event monitoring is disabled...\n" );
                RTEventButton->setOn( TRUE );
                MIDIEventButton->setOn( TRUE );
            }
		}
		else
		{
            //Error ( " -- Stopping real-time MIDI monitoring...\n" );
            MIDIEventButton->setOn( FALSE );
        }
    }
	if ( Ptr->ID == 22 )
	{
        //PLAY
        PlayPtr = Ptr;
        PlaybackStatus = 5;
	}
    //qDebug("A");
    return 0;
}








int RTMix::UpdateCounter()
{
    eventCue *tmp, *old;
    bool loop;
    
    if ( PlaybackStatus > 3 || PlaybackStatus <=3 && RTEventButton->isOn() )
    {
		if ( AbsMove != NULL && AbsMove->time == A->GetTimeCount() )
		{
			//qDebug(AbsMove->text + " AbsEvent %i", AbsMove->time ); //DEBUG
			//qDebug( "ABS EVENT" );
			InterpretCue( AbsMove );
			position = 0; //used as a true/false variable in the condition below
			while ( AbsMove->next != NULL && !position )
			{
             		AbsMove = AbsMove->next;
				if ( AbsMove->time == A->GetTimeCount() && AbsMove->absat == 1 )
				{
                  InterpretCue( AbsMove );
				}
				else if ( AbsMove->absat == 1 )
				{
					position = 1;
				}
			}
			if ( AbsMove->next == NULL && AbsMove->absat == 0 )
			{
             		AbsMove = NULL;
			}
		}
    }
    if (PlaybackStatus > 3)
	{
       //CHECK THE CUE RIGHT HERE FOR "0" OR POST-JUMP EVENTS
       if ( Move->time == TimeCount && FollowMove != Move && nEvents > 0 )
       {
          //qDebug("BANG!");
          //qDebug( "say1 " + Move->text );
          tmp = Move;
          if ( Move->absat == 0 )
          {
              InterpretCue( Move );
          }
          if ( Move->ID == 5 )
          {
              if ( Move->next != NULL && tmp == Move )
              {
                  Move = Move->next;
              }              
              return 0;
          }
          loop = true;
          //qDebug( "%d", tmp->ID );
          if ( Move->next != NULL && tmp == Move )
          {
              Move = Move->next;
          }
          else if ( Move->next == NULL && tmp == Move )
          {
              loop = false;
          }
          while ( Move->time == TimeCount && loop )
          {
              //qDebug("x");
              //qDebug( "%d", tmp->ID );
              //qDebug( "%d", Move->ID );
              //qDebug( "say1 " + Move->text );
              if ( Move == tmp )
              {
                  Error ( " -- CRITICAL ERROR: found infinite recursion in your scriptfile. Terminating playback..." );
                  Stop( NULL );
                  return 0;
              }
              old = Move;
              if ( Move->absat == 0 )
              {
                  InterpretCue( Move );
              }
              if ( Move->next != NULL &&  old == Move )
              {
                  Move = Move->next;
                  //qDebug(" >> ");
              }
              else if ( Move->next == NULL )
              {
                  loop = false;
              }
			}
		//return 0;
		}

		UpdateLightEvents();
		TimeCount++;
		E->UpdateCounter();
		A->UpdateCounter();
			
		if (RTMix::NCentisecond->intValue() < 9) {
			RTMix::NCentisecond->display(RTMix::NCentisecond->intValue() + 1);
		}
		else {
			RTMix::NCentisecond->display(0);
			if (RTMix::NTenCentisecond->intValue() < 9) {
				RTMix::NTenCentisecond->display(RTMix::NTenCentisecond->intValue() + 1);
			}
			else {
				RTMix::NTenCentisecond->display(0);
				if (RTMix::NSecond->intValue() < 9) {
					RTMix::NSecond->display(RTMix::NSecond->intValue() + 1);
				}
				else {
					RTMix::NSecond->display(0);
					if (RTMix::NTenSecond->intValue() < 5) {
						RTMix::NTenSecond->display(RTMix::NTenSecond->intValue() + 1);
					}
					else {
						RTMix::NTenSecond->display(0);
						if (RTMix::NMinute->intValue() < 9) {
							RTMix::NMinute->display(RTMix::NMinute->intValue() + 1);
						}
						else {
							RTMix::NMinute->display(0);
							if (RTMix::NTenMinute->intValue() < 5) {
								RTMix::NTenMinute->display(RTMix::NTenMinute->intValue() + 1);
							}
							else {
								RTMix::NTenMinute->display(0);
								if (RTMix::NHour->intValue() < 99) {
									RTMix::NHour->display(RTMix::NHour->intValue() + 1);
								}
								else {
									RTMix::NHour->display(0);
									RTMix::TimeCount = 0;
									RTMix::Stop( NULL );
								}
							}
						}
					}
				}
			}
		}
		//CHECK THE CUE RIGHT HERE FOR EVENTS
		//qDebug( "ID %i -- %i -- %i", Move->ID, Move->time, TimeCount );
		if ( Move->time == TimeCount ) {
          tmp = Move;
          if ( Move->absat == 0 )
          {
              //qDebug( "check %d", Move->ID );
              //qDebug( "say2 " + Move->text );
              InterpretCue( Move );
          }
          if ( Move->ID == 5 )
          {
              if ( Move->next != NULL && tmp == Move )
              {
                  Move = Move->next;
              }
              return 0;
          }
          loop = true;
      
          if ( Move->next != NULL && tmp == Move )
          {
              Move = Move->next;
          }
          else if ( Move->next == NULL && tmp == Move )
          {
              loop = false;
          }
          while ( Move->time == TimeCount && loop )
          {
              //qDebug("x");
              //qDebug( "tmp %d", tmp->ID );
              //qDebug( "move %d", Move->ID );
              //qDebug( "say2 " + Move->text );
              if ( Move == tmp )
              {
                  Error ( " -- CRITICAL ERROR: found infinite recursion in your scriptfile. Terminating playback..." );
                  Stop( NULL );
                  return 0;
              }
              old = Move;
              if ( Move->absat == 0 )
              {
                  InterpretCue( Move );
              }
              if ( Move->next != NULL &&  old == Move )
              {
                  Move = Move->next;
                  //qDebug(" >> ");
              }
              else if ( old == Move )
              {
                 loop = false;
              }
          }
          /*
			if ( Move != End && Move->next->time == TimeCount ) {
				while ( Move != End && Move->next->time == TimeCount ) {
					Move = Move->next;
					if ( Move->absat == 0 )
					{
                      if ( Move ==  tmp )
                      {
                          Error ( " -- critical error: found infinite recursion. Stopping playback..." );
                          Stop();
                          return 0;
                      }
                      old = Move;
						InterpretCue( Move );
					}
				}
				if ( Move != End && old == Move ) {
					Move = Move->next;
				}
			}
			else {
				if ( Move != End ) {
					Move = Move->next;
				}
			}
*/
        }

         //qDebug( "%i, %i" , AbsMove->time, A->GetTimeCount() );
    }
    return 0;
}





int RTMix::AssignValue( struct eventCue *e, double n )
{
	eventCue *Dest;
	QString temp, temp2;
	bool error;
	double oldN;
    int tmpType;

	oldN = n;
	error = false;
	Dest = e;
	temp2 = "";

	Error( " -- FUNC = " + temp.setNum( n ) + ".\n" );

	//qDebug( "Change type %i", e->type );

	if ( e->type < 0 && e->type > -2000 ) //REFLECTS THAT THE CALL IS FOR THE REAL-TIME EVENT
	{
		//qDebug( "ASSIGNING RT EVENT %i", -(e->type) - 1000 );
		Dest = RTEvents[ -(e->type) - 1000 ];
       if ( Dest == NULL )
       {
           return -3;
       }
       //qDebug( "1000-2000" );
	}
   else if ( e->type < -2999 )
   {
      //this is a modular value within a RTEvent value
      Dest = RTEvents[ int(RandomNum[ -(e->type) - 3000 ]) ];
      if ( Dest == NULL )
      {
          return -3;
      }
      //qDebug( "3000" );      
   }
	else
	{
       if ( e->type < -1999 && e->type > -3000 )
       {
           //this is modular value
           //qDebug( "e-type %d", e->type );
           //qDebug( "randomnum", RandomNum[e->type - 2000] );
           tmpType = int (RandomNum[ -(e->type) - 2000 ]);
           //qDebug( "2000-3000 %d", tmpType );
       }
       else
       {
          if ( e->next != NULL )
          {
              tmpType = e->next->ID;
          }
          else
          {
              tmpType = 0;
          }
       }
       //qDebug( "tmptype  %d time %d", tmpType, e->time );
    	if ( Dest->next != NULL )
    	{
           //qDebug("boo!");
           Dest = Dest->next;
         	while ( Dest->next != NULL && Dest->absat != e->absat || Dest->next != NULL && Dest->ID != tmpType  ) //random value corresponds only to the event with same absat value
    		{
              //qDebug( "||" );
    			if ( Dest->next != NULL && Dest->absat != e->absat || Dest->next != NULL && Dest->ID != tmpType )
    			{
    				Dest = Dest->next;
    				//qDebug ( ">" );
    			}
    		}
    	}
    	if ( Dest == e || Dest == End && e->absat != Dest->absat || Dest == End && Dest->ID != tmpType || tmpType > 0 && Dest->ID != tmpType )
    	{
          //if ( Dest == e ) { qDebug (" dest = e" );  }
          //if ( Dest == End ) { qDebug (" dest = end" );  }
          //if ( e->absat == Dest->absat ) { qDebug (" e-absat = dest-absat" );  }
          //if ( tmpType == Dest->ID ) { qDebug (" tmpType  = tmpType " );  }
          //qDebug( "time %d ID %d", Dest->time, Dest->ID );          
          //qDebug("bobobobo");
        	Error( " -- Error: the 'change' call has nothing to change because no applicable event was found in the cue following the 'change' event...\n" );
    		return 0;     			
    	} 
		//qDebug ( "%G, dest ID %i", n, Dest->ID );
	}
	//qDebug ( "%G, dest ID %i", n, Dest->ID );

	if (e->var == "value" ) {
		if ( Dest->ID != 13 ) { return -1; }
		if ( n < 0 ) { n = 0; error = true; }
		Dest->amt = n;		
	}
	if (e->var == "abs" ) {	
		if ( Dest->ID != 10 ) { return -1; }
		if ( n < 0.5 ) { n = 0; error = true; }
		if ( n >= 0.5 ) { n = 1; error = true; }
		Dest->event = temp.setNum( n );
	}
	if (e->var == "meter" ) {
		if ( Dest->ID != 9 ) { return -1; }
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 50 ) { n = 50; error = true; }
		Dest->event = temp.setNum( int( n + 0.5 ), 10 );
	}
	if (e->var == "event" ) {	
		if ( n < 1 ) { n = 1; error = true; }
		if ( n > totalEvents ) { n = totalEvents; error = true; }
		Dest->ID = int( n + 0.5 );
	}
	if (e->var == "at" ) {	
		n = int( n * 100.0 );
		if ( Dest->prev != NULL && n < Dest->prev->time - Dest->time ) { n = Dest->prev->time - Dest->time; error = true; }
		if ( Dest->next != NULL && n > Dest->next->time - Dest->time ) { n = Dest->next->time - Dest->time; error = true; }
		Dest->time = Dest->time + int ( n + 0.5 );
		temp2.setNum ( n/100 );
	}
	if (e->var == "dur" ) {	
		if ( n < 0 ) { n = 0; }
		if ( n > 35999999 ) { n = 35999999; error = true; }
		Dest->countdown = int( n + 0.5 );
	}
	if (e->var == "absat" ) {	
		if ( n < 0.5 ) { n = 0; }
		else { n = 1; }
		Dest->absat = int ( n );
	}
	if (e->var == "happen" ) {
		n = int(n * 10000.0);
		if ( n < 0 ) { n = 0; error = true; }	
		if ( n > 10000 ) { n = 10000; error = true; }	
		Dest->happen = int ( n );
		temp2.setNum ( n/10000 );
	}
	if (e->var == "chance" ) {	
		n = int(n * 10000.0);
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 10000 ) { n = 10000; error = true; }	
		Dest->chance = int ( n );		
		temp2.setNum ( n/10000 );
	}
	if (e->var == "color" ) {	
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 16777215 ) { n = 16777215; error = true; }
		temp.setNum( int( n ), 16 );
		if ( temp.length () == 1 ) { temp = "00000" + temp; }
		if ( temp.length () == 2 ) { temp = "0000" + temp; }
		if ( temp.length () == 3 ) { temp = "000" + temp; }
		if ( temp.length () == 4 ) { temp = "00" + temp; }
		if ( temp.length () == 5 ) { temp = "0" + temp; }
		Dest->color = temp;			
	}
	if (e->var == "light" ) {	
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 13 ) { n = 13; error = true; }
		Dest->light = int ( n + 0.5 );
	}
	if (e->var == "blinkspeed" ) {
		n = int ( n * 100 );	
		if ( n < 10 ) { n = 10; error = true; }
		if ( n > 1000 ) { n = 1000; error = true; }
		Dest->blinkSpeed = int ( n );
		temp2.setNum ( n/100 );
	}
	if (e->var == "store" ) {	
		if ( Dest->ID != 11 ) { return -1; }
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 255 ) { n = 255; error = true; }
		Dest->bpm = int ( n + 0.5 );				
	}
	if ( e->var == "status" ) {
		if ( Dest->ID != 16 && Dest->ID != 18 && Dest->ID != 20 ) { return -1; }
		if ( Dest->ID == 16 && n > 3 ) { n = 3; error = true; }
		if ( Dest->ID == 18 && n > 1 || Dest->ID == 20 && n > 1 || Dest->ID == 21 && n > 1 ) { n = 1; error = true; }
		if ( n < 0 ) { n = 0; error = true; }
		Dest->bpm = int ( n + 0.5 );
	}
	if ( e->var == "amt" ) {
		if ( Dest->ID != 17 ) { return -1; }
		Dest->amt = n;
	}
	if ( e->var == "preplength" ) {
		n  = int ( n * 100 );
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 6000 ) { n = 6000; error = true; }
		Dest->prepLength = int ( n + 0.5 );
		temp2.setNum ( n/100 );
	}
	if ( e->var == "lightlength" ) {
		n = int ( n * 100 );
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 1000 ) { n = 1000; error = true; }
		Dest->lightLength = int ( n + 0.5 );
		temp2.setNum ( n/100 );
	}
	if ( e->var == "net" ) {
		if ( Dest->ID == 4 || Dest->ID == 5 || Dest->ID == 6 || Dest->ID == 10 || Dest->ID == 11 || Dest->ID == 12 ||
          Dest->ID == 13 || Dest->ID == 14 || Dest->ID == 15 || Dest->ID == 17 || Dest->ID == 18 || Dest->ID == 19 ||
          Dest->ID == 20 || Dest->ID == 21 ) { return -2; }
		if ( n < -2 ) { n = -2; error = true; }
		if ( n > 255 ) { n = 255; error = true; }
		Dest->netAddress = int ( n );
	}
	if ( e->var == "bpm" ) {
		if ( Dest->ID != 9 ) { return -1; }
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 1200 ) { n = 1200; error = true; }
		Dest->bpm = int ( n + 0.5 );
	}
	if ( e->var == "type" ) {
		if ( Dest->ID != 11 ) { return -1; }
		if ( n < 0.5 ) { n = 0; }
		else { n = 1; }
		Dest->type = int ( n );
	}
	if ( e->var == "method" ) {
		if ( Dest->ID != 11 ) { return -1; }
		if ( n < 0 ) { n = 0; error = true; }
		if ( n > 6 ) { n = 6; error = true; }
		Dest->method = int ( n + 0.5 );
	}
	if ( e->var == "num" ) {
		if ( Dest->ID != 9 && Dest->ID != 16 ) { return -1; }
		if ( n < 1 ) { n = 1; error = true; }
		if ( n > 4 ) { n = 4; error = true; }
		Dest->type = int ( n + 0.5 );		
	}
	if ( e->var == "to" ) {
		if ( Dest->ID != 10 && Dest->ID != 14 && Dest->ID != 15 ) { return -1; }
		//qDebug( "bpm %i", Dest->bpm );
		Dest->bpm = int ( n );
		//qDebug( "bpm %i", Dest->bpm );
	}
	if ( e->var == "id" ) {
		if ( Dest->ID != 12 || Dest->ID != 20 ) { return -1; }
		//if ( n < 0 ) { n = 0; error = true; }
		if ( Dest->ID == 12 )
		{
			if (  n < 0 ) { n = 0; error = true; }
			if (  n > totalEvents ) { n = totalEvents; error = true; }
		}
		if ( Dest->ID == 20 )
		{
			if ( n < -2 ) { n = -2; error = true; }
			if ( n > 255 ) { n = 255; error = true; }
		}

		Dest->type = int ( n + 0.5 );
	}
	//qDebug ( temp.setNum( n ) );
	if ( error )
	{
		if ( temp2 == "" )
		{
         	temp2.setNum ( n );
		}
		Error( " -- The result of the 'change' call has been adjusted to fit the boundaries of the requested variable ( " + temp.setNum( oldN ) + " => " + temp2 + " )...\n" );     	
	}
	if ( Dest->time < 0 )
	{
     	RTEventTable->setText( (-(Dest->time) - 1000), 3, "*" );
	}
    //qDebug ( "time %d newval %d", Dest->time, Dest->bpm );
  return 0;
}

////////////////////////////////////OSC STUFF//////////////////////////////////////////////


void RTMix::ParseRtMidiMessage( int a, int b, int c )
{
    QString message;
    //const char *sendMsg;
    QString num;
    int i, tmp;

    midi_1 = a;
    midi_2 = b;
    midi_3 = c;

    //qDebug( "command = %d %d %d", a, b, c );

    tmp = a % 16; //let's figure out which channel we're talking about
    tmp++; //let's make it 1-16 rather than 0-15
    //qDebug( "tmp = %d > ", tmp );

    if ( haveOSC )
    {
         num.setNum( tmp, 10 );
         if ( a > 0x7F && a <= 0x8F ) //noteoff
         {
              message = "/midi/"+ num + "/noteoff";
         }
         if ( a > 0x8F && a <= 0x9F ) //noteon
         {
              if ( c > 0 )
              {
                  message = "/midi/"+ num + "/noteon";
              }
              else //when velocity is 0, it's treated as a noteoff
              {
                  message = "/midi/"+ num + "/noteoff";
              }
         }
         if ( a > 0x9F && a <= 0xAF ) //aftertouch
         {
              message = "/midi/"+ num + "/polyaftertouch";
         }
         if ( a > 0xAF && a <= 0xBF ) //control change (mode change when b > 0x79)
         {
              message = "/midi/"+ num + "/control";
         }
         if ( a > 0xBF && a <= 0xCF ) //program change
         {
              message = "/midi/"+ num + "/program";
         }
         if ( a > 0xCF && a <= 0xDF ) //channel aftertouch
         {
              message = "/midi/"+ num + "/aftertouch";
         }
         if ( a > 0xDF && a <= 0xEF ) //pitchbend (16-bit resolution)
         {
              message = "/midi/"+ num + "/pitchbend";
         }
    }
     //qDebug( message );

     //compare all events to see what needs to be triggered
     for ( i = 0; i < 256; i++ )
     {
        //TEST FOR OSCROUTE STUFF
        if ( haveOSC )
        {
            if ( RTEvents[i] != NULL && RTEvents[i]->OSCPtr != NULL && RTEvents[i]->event.lower().find("oscroute:",0) != -1 )
            {
                if ( a >= RTEvents[i]->la && a <= RTEvents[i]->ha )
                {
                    if ( b >= RTEvents[i]->lb && b <= RTEvents[i]->hb )
                    {
                        if ( c != -1 && c >= RTEvents[i]->lc && c <= RTEvents[i]->hc )
                        {
                            RTEvents[i]->OSCPtr->WriteMessage( const_cast<char *>((const char*) message), b, c );
                        }
                    }
                }
            }
        }
        //NOW TEST FOR MIDI-TRIGGERED EVENTS
        if ( RTEvents[i] != NULL && RTEvents[i]->accel.lower().find("midi:", 0) != -1 && RTEvents[i]->event.lower().find("oscroute:", 0) == -1 )
        {
            if ( a >= RTEvents[i]->la && a <= RTEvents[i]->ha )
            {
                if ( b >= RTEvents[i]->lb && b <= RTEvents[i]->hb )
                {
                    if ( c >= RTEvents[i]->lc && c <= RTEvents[i]->hc )
                    {
                        if ( RTEvents[i]->event.endsWith("&") )
                        {
                            //qDebug("Ends with &");
                            //qDebug( "lasttime curtime %d %d", RTEvents[i]->lastTime, A->GetTimeCount() );
                            if ( RTEvents[i]->last1 != a || RTEvents[i]->last2 != b && c == -1 && RTEvents[i]->lastTime < A->GetTimeCount()-4 ||
                                RTEvents[i]->last3 != c && RTEvents[i]->lastTime < A->GetTimeCount()-4 || RTEvents[i]->last1 == a &&
                                RTEvents[i]->last2 == b && RTEvents[i]->last3 == c && RTEvents[i]->lastTime < A->GetTimeCount()-4 )
                            { 
                                InterpretCue( RTEvents[i] );
                                //qDebug( "YES" );
                                RTEvents[i]->lastTime = A->GetTimeCount();
                                RTEvents[i]->last1 = a;
                                RTEvents[i]->last2 = b;
                                RTEvents[i]->last3 = c;
                            }
                        }
                        else
                        {
                            InterpretCue( RTEvents[i] );
                            RTEvents[i]->lastTime = A->GetTimeCount();
                            RTEvents[i]->last1 = a;
                            RTEvents[i]->last2 = b;
                            RTEvents[i]->last3 = c;                                               
                        }
                    }
                }
            }
        }
    }
    midi_1 = -1;
    midi_2 = -1;
    midi_3 = -1;
}
