/***************************************************************************
                          rtmix.h  -  description
                             -------------------
    begin                : Thu Nov 13 2001
    copyright            : (C) 2001 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef RTMIX_H
#define RTMIX_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include <kapp.h>
#include <qvariant.h>
#include <qwidget.h>
#include <qmovie.h>
#include <qtextbrowser.h>
#include <qwhatsthis.h>

#include <pthread.h>

#include "QLCD.h"
#include "eventcue.h"
#include "warning.h"
#include "metro.h"
#include "ledwindow.h"
#include "errorlog.h"
#include "externaltimer.h"
#include "version.h"
#include "splash.h"

class QTableDisplay;
class QVBoxLayout;
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QGroupBox;
class QLCDNumber;
class QLabel;
class QTextEdit;
class QPushButton;
class QTabWidget;
class Client;
class settings;
class SimpleServer;
class QMidi;
class OSCEvent;
class MyTimer;
//class QLineEdit;

class RTMix : public QWidget
{
    Q_OBJECT
public:
    RTMix( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~RTMix();

    QPalette palTime;
    QColorGroup cgTime;
    QPalette palWarn;
    QColorGroup cgWarn;
    QPalette palError;
    QColorGroup cgError;
    QPalette palEdit;
    QColorGroup cgEdit;
    QPalette palText;
    QColorGroup cgText;
    QPalette palRT;
    QColorGroup cgRT;

    QLabel* PixmapLogo;
    QFrame* Separator3;
    QFrame* Separator2;
    QFrame* Separator1;
    QPushButton* PlayButton;
    QPushButton* QuitButton;
    QGroupBox* TimerGroupBox;
    QLCD* NSecond;
    QLCD* NTenSecond;
    QLabel* PlayIndicator;
    QLabel* PlayIndicatorLabel;
    QLabel* SecondsLabel;
    QLabel* MinutesLabel;
    QLabel* HoursLabel;
    QLabel* DecisecondsLabel;
    QLCD* NCentisecond;
    QLCD* NTenCentisecond;
    QLabel* TimerLeftEdge;
    QLabel* TimerRightEdge;
    QLCD* NHour;
    QLCD* NMinute;
    QLCD* NTenMinute;

    //QLabel* HourMinuteColumn;
	QLCDNumber* HourMinuteColumn;
    QLCDNumber* MinuteSecondColumn;
    QLCDNumber* SecondCentisecondDot;

    QTabWidget* Tabs;
    QWidget* PlayTab;
    QLabel* TextLabel2;
    QLabel* NotificationBottomEdge;
    QLabel* NotificationTopEdge;
    QTextBrowser* TextInterface;
    QWidget* tab;
    QPushButton* SaveAsButton;
    QPushButton* SaveButton;
    QPushButton* OpenButton;
    //QLabel* ErrorLogLabel;
    QLabel* EditWindowLabel;
    QPushButton* CompileButton;
    //QTextBrowser* ErrorLog;
    QTextEdit* Editor;
    QWidget* tab_2;
    QWidget* tab_3;
    QWidget* tab_4;
    QGroupBox* WarnGroupBox;
    QLCDNumber* NWarnTenMinute;
    QLCDNumber* NWarnMinute;
    QLCDNumber* NWarnTenSecond;
    QLCDNumber* NWarnSecond;
    QLabel* WarnExecute;
    QLabel* WarningSecondsLabel;
    QLabel* WarnIndicator;
    QLabel* WarningIndicatorLabel;
    QLabel* WarningMinutesLabel;
    QLabel* ExecuteIndicatorLabel;
    QLabel* WarningDecisecondsLabel;
    QLCDNumber* NWarnCentisecond;
    QLCDNumber* NWarnTenCentisecond;
    QLabel* WarningLeftEdge;
    QLabel* WarningRightEdge;

    QLCDNumber* WarnMinuteSecondColumn;
    QLCDNumber* WarnSecondCentisecondDot;

    QPushButton* WhatIsThisButton;
    QPushButton* AboutButton;
    QPushButton* PanicButton;
    QPushButton* StopButton;
    QPushButton* FForwardButton;
    QPushButton* RewindButton;
    QPushButton* PauseButton;
    QPushButton* SizeButton;

    QPushButton* PurgeButton;
    QPushButton* EditButton;
    QPushButton* RefreshButton;
    QPushButton* ErrorButton;
    QPushButton* NewButton;
    QPushButton* GoToButton;

    QLabel* EditorLineNumber;

    QTableDisplay* RTEventTable;
    QPushButton* RTEventButton;
    QPushButton* MIDIEventButton;
    QPushButton* MIDILogButton;
    QPushButton* VerboseButton;
    QPushButton* RTPurgeButton;
    QLabel* RTEventLabel;

    QGroupBox* LocalhostGroupBox;
    QLabel* SocketLabel;
    QLabel* StatusLabel;
    QPushButton* StopSocket;
    QPushButton* StartSocket;
    QLabel* Status;
    QLabel* Socket;
    QGroupBox* ExternalClientsGroupBox;
    QTableDisplay* ExternalClientsTable;
    QPushButton* StartSelectedButton;
    QFrame* NetworkSpacerLine;
    QPushButton* StopAllButton;
    QPushButton* StartAllButton;
    QPushButton* StopSelectedButton;

	int PlaybackStatus;

    QPixmap			imageRedoff;
	QPixmap 			imageRedon;

	QPixmap			imageYellowoff;
	QPixmap			imageYellowon;

	QPixmap			imageGreenoff;
	QPixmap			imageGreenon;

	QPixmap			imageRewind;
	QPixmap			imageFForward;
	QPixmap			imageRewindOff;
	QPixmap			imageFForwardOff;

	//ALL EXTERNAL WINDOWS ARE PUBLIC SO THAT THE SETTINGS WINDOW CAN ACCESS THEM
	Metronome *Metro1;
	Metronome *Metro2;
	Metronome *Metro3;
	Metronome *Metro4;

	Warning_Window *Window1;
	Warning_Window *Window2;
    Warning_Window *Window3;
	Warning_Window *Window4;

	LEDWindow *LEDw;
	settings *S;
	TextWindow *T;
	ExternalTimer *E;
	ExternalTimer *A; //absolute timer that counts full time of the performance
	Splash *Sp;

	bool CurrSize;
	QString DefaultTextInterfaceColor;
	QString versionNo;

    void AutoOpenFile( QString );

    SimpleServer *local;
  
    long TimeCount;
    void AdjustTimer( QString );
    int InterpretCue( struct eventCue* );
    QString netEvents; //stores all events invoked from remote hosts

    int SpawnMidi( QString );
    QMidi *Midi;

    QString GetNetAuth();
    QString LastSent;
    //long LastSentTime;
    //QString ParseTime();
  
protected:
    //bool event( QEvent* );
    void keyPressEvent ( QKeyEvent* );
    void keyReleaseEvent ( QKeyEvent* );
    void customEvent ( QCustomEvent* );
    void closeEvent ( QCloseEvent * );

private:
	struct eventCue *EventPtr;
	struct eventCue *CountdownPtr;
	struct eventCue *TextPtr;
	struct eventCue *CheckpointPtr;
	//struct eventCue *PausePtr;
	//struct eventCue *StopPtr;
	struct eventCue *ClearPtr;
	struct eventCue *WarningPtr;
	struct eventCue *MetroPtr;
	struct eventCue *JumpPtr;
	struct eventCue *RandPtr;
	struct eventCue *ChangePtr;
	struct eventCue *SeedPtr;
	struct eventCue *RewPtr;
	struct eventCue *FfwPtr;
	struct eventCue *ToggleMetroPtr;	
	struct eventCue *AssignPtr;	
	struct eventCue *ToggleRTPtr;
	//struct eventCue *SetNetPtr;
	struct eventCue *ToggleNetPtr;
	struct eventCue *ToggleMIDIPtr;
	struct eventCue *PlayPtr;
    
	struct eventCue *Start;
	struct eventCue *End;
	struct eventCue *Curr;
	struct eventCue *Move;
	struct eventCue *FollowMove;
	struct eventCue *TempCurr;

	struct eventCue *StartCopy;
	struct eventCue *CurrCopy;
	struct eventCue *EndCopy;
	struct eventCue *MoveCopy;	

	struct eventCue *AbsMove;

    bool CompileFlag;
    int line; //line numbering tool for tracking errors at compile-time
  
	int PauseCounter;
	int WarnIndicatorBlinkStatus;

	QString compareFile;
	QString compareCompile;
	//QString WarnEvent;

	int nEvents;

	long CountdownCount;
	long WarningCount;

	int OldPlaybackStatus;
	
	QString inputFile;
	QString outputFile;
	
	bool Edit;
	void AllowEdit();
	void DisableEdit();

	void PurgeCue();
	void ResetCue();
	void CopyCue( struct eventCue*, struct eventCue* );
	void AdjustWarnTimer( struct eventCue* );
	void ClearWarning();
	void UpdateWarnDisplay();
	void AdjustOtherTimers( struct eventCue* );
	void ResetOtherTimers();
	void ResetPlayer();

	int position;
	int startposition;
	int endposition;
	QString Do(QString, QString, QString);
	long At(QString, QString, QString);
	QString Text(QString, QString, QString);
	QString Kill(QString, QString, QString);
	long Dur(QString, QString, QString);

	long Happen(QString, QString, QString);
	long Chance(QString, QString, QString);
	QString Color(QString, QString, QString);
	int Light(QString, QString, QString);
	int BlinkSpeed(QString, QString, QString);
	int LightLength(QString, QString, QString);
	int prepLength(QString, QString, QString);
	int NetAddress(QString, QString, QString);
	int Bpm(QString, QString, QString);
	int MetNum(QString, QString, QString);
	QString Meter(QString, QString, QString);
	QString Jump(QString, QString, QString);
	QString Func(QString, QString, QString);
	QString Var(QString, QString, QString);
	int Type(QString, QString, QString);
	long SeedType(QString, QString, QString);
	QString Abs(QString, QString, QString);
	int MetroStatus(QString, QString, QString);
	int RTStatus(QString, QString, QString);
	int Absat(QString, QString, QString);
	int RandVar(QString, QString, QString);
	int Method(QString, QString, QString);
	float Amt(QString, QString, QString);
	int ID(QString, QString, QString);
	QString Accel(QString, QString, QString);
	QString Host(QString, QString, QString);
	int Port(QString, QString, QString);
	int NetID(QString, QString, QString);
	int NetStore(QString, QString, QString);
	QString Amount(QString, QString, QString);

	void ToggleNetwork( int, bool );
	void PurgeNetwork();
	void SendGlobal( QString );
    void SendSingle( QString, int );
	void SendGlobalEvent( struct eventCue * );
	void SendSingleEvent( struct eventCue * );
	void ChangeLocalSocket( int );
	Client *net[MAXNET+1];
    QString ParseNetEvent( struct eventCue *e );
	int socket;
	int ExternalClientsTableSelected;
	bool NetActive;
	bool HostingActive;

	int CheckOptional(QString, QString, QString);

	void UpdateLights(struct eventCue*, long);
	void ClearContinuousEvents( bool );

	float RandomNum[MAXVARS+1];
	long RandSeed;
	int AssignValue( struct eventCue*, double );

  struct eventCue *RTEvents[MAXRTEVENTS+1];
  struct eventCue *RTEventsCopy[MAXRTEVENTS+1];
  void ResetRTTable( bool );

  bool CompileComments;
  
  //OSCEvent *OSC[256]; //OSC is now a part of the eventcue
  bool haveOSC;

  int midi_1, midi_2, midi_3;

  bool ErrorCompile;
  bool Verbose;
  void AdjustRTLastTimes();

  MyTimer* timer;
  
public slots:

  void ReceiveKeyPressEvent( QKeyEvent* );
  void ReceiveKeyReleaseEvent( QKeyEvent* );
  
  void UpdateLightEvents();
  void UpdatePause();
  int UpdateCounter();
  void UpdateMetros();

  void ToggleMidiLog( bool );
  void ToggleVerbose( bool );

  void ToggleSize( int );

  void Error( QString );
  void GoToError();

  void UpdateNetStatus( int, QString );
  void UpdateHostStatus( QString );

  void Stop( QString );
  int Play( QString );
  void Pause( QString );
  int FF();
  int REW();
  void Panic( QString );
  
  void ParseRtMidiMessage( int, int, int );
  void AnnounceRT( bool );
  void AnnounceMIDI( bool );
  
private slots:

	void OpenSettings();
	void UpdateCountdown();
	void UpdateWarning();
	void OpenConsole();

    void Do_Panic();
    void Do_Play();
    void Do_Stop();
    void Do_Pause();

	void HelpMode();
	void Purge();

	int New();
	int OpenFile();
	int SaveFile();
	int SaveAsFile();

	int Compile();

	int Quit();

	void IncreaseHour();
	void DecreaseHour();
	void IncreaseTenMinute();
	void DecreaseTenMinute();
	void IncreaseMinute();
	void DecreaseMinute();
	void IncreaseTenSecond();
	void DecreaseTenSecond();
	void IncreaseSecond();
	void DecreaseSecond();
	void IncreaseTenCentisecond();
	void DecreaseTenCentisecond();
	void IncreaseCentisecond();
	void DecreaseCentisecond();

	void OpenExternEditor();
	int RefreshEditor();

	void EmitMetroError( QString );

	void SelectExternalClient( int, int );
	void RemoveExternalClientSelection( int, int );

	void StopSelectedClient();
	void StartSelectedClient();
	void StopAllClients();
	void StartAllClients();
	void StopHost();
	void StartHost();
	void ResetRow();

    void UpdateEditorLine( int, int );
    void setPlaybackStatus( int );

};

#endif // RTMIX_H
