/***************************************************************************
                          settings-globals.h  -  description
                             -------------------
    begin                : Thu Aug 22 2002
    copyright            : (C) 2002 by Ivica Bukvic
    email                : ico@fuse.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGS_GLOBALS_H
#define SETTINGS_GLOBALS_H

#include "path.h"

void settings::ApplyAllSettings()
{
    UpdateWidgets( 2 );
    ApplyButton->setEnabled( FALSE );
}

void settings::OK()
{
    ApplyAllSettings();
    ApplyButton->setEnabled( FALSE );
    close();
}

void settings::HelpMode()
{
    QWhatsThis::enterWhatsThisMode();
}

void settings::SaveSettings()
{
    ApplyAllSettings();
    WriteSettings( Saved );
}

void settings::ResetAll()
{
    //qDebug ( "Current: " + Current->NetAuth );
    //qDebug ( "Saved: " + Saved->NetAuth );
    UpdateWidgets( 1 );
    ApplyButton->setEnabled( TRUE );
}

QString settings::GetAccel( int n )
{
    return Current->Accel[n];
}

void settings::IncreaseLCD()
{
    if (PreviewLCD->intValue() < 99) {
      PreviewLCD->display( PreviewLCD->intValue() + 1 );
    }
    else {
        PreviewLCD->display( 0 );  //number rolls around
    }
}

void settings::DecreaseLCD()
{
    if (PreviewLCD->intValue() > 0) {
        PreviewLCD->display( PreviewLCD->intValue() -1 );
    }
    else {
        PreviewLCD->display( 99 );  //number rolls around
    }
}

QString settings::GetEditor()
{
    return Current->Editor;
}

QString settings::GetMidiPort()
{
    return Current->MidiPort;
}

void settings::ConnectMidi()
{
    R->SpawnMidi( GetMidiPort() );
}

void settings::Close()
{
    UpdateWidgets( 3 );
    close();
}

void settings::ApplyMidiPort()
{
    Current->MidiPort = MidiPortEdit->text();
    ApplyButton->setEnabled( TRUE );
}

void settings::ApplyBrowser()
{
    Current->Browser = BrowserLineEdit->text();
    ApplyButton->setEnabled( TRUE );
}

void settings::SpawnHelp()
{
    system( Saved->Browser + " " + path + "/doc/index.html&" );
    R->Error( "Spawning documentation using the default HTML browser \
(this may take a moment depending on speed of your computer)..." );
}

QString settings::GetNetAuth()
{
    return Saved->NetAuth;
}

QString settings::GetFilter()
{
    return Saved->EventFilter;
}

void settings::ResetApplyButton()
{
    ApplyButton->setOn( FALSE );
}

#endif
